#!/usr/bin/bash

# this script does the webcam ctrl magic, for OBSBOT tiny pan/tilt/zoom camera (PTZ)
# it REQUIRES the v4l2 utilities ( v4l2-utils on opensuse, name may vary )

# basic things only : pan,tilt,zoom, exposure, gain. the rest can be done from 
# the official OBSBOT Remo app ( if you have windows...)  or from webcamoid or obs-studio 
# if you have some kind of linux.
# it can easily be expanded, and use in your own app if you have linux... or use videograbber (and modify it)
# look at the section where multiple settings are done ... thats how it works.
# sample output :
#= v4l2-ctl -d 2  --list-devices  # get device list NB! only first device works, e.g. video2. 
#OBSBOT Tiny 4K: OBSBOT Tiny 4K  (usb-0000:00:14.0-1.1):
#        /dev/video2
#        /dev/video3
#
#C922 Pro Stream Webcam (usb-0000:00:14.0-1.4):
#        /dev/video4
#        /dev/video5
#
#HD WebCam: HD WebCam (usb-0000:00:14.0-5):
#        /dev/video0
#        /dev/video1

# v4l2 -d 2 -l # partial..!!
#              exposure_absolute 0x009a0902 (int)    : min=1 max=2500 step=1 default=330 value=800
#                   pan_absolute 0x009a0908 (int)    : min=-468000 max=468000 step=3600 default=0 value=43164
#                  tilt_absolute 0x009a0909 (int)    : min=-324000 max=324000 step=7200 default=0 value=216
#                 focus_absolute 0x009a090a (int)    : min=0 max=100 step=1 default=0 value=0 flags=inactive
#                     focus_auto 0x009a090c (bool)   : default=1 value=1


function pantilt
{

v4l2-ctl -d $camdev  -c pan_absolute=1
sleep 0.2
v4l2-ctl -d $camdev   -c tilt_absolute=1
sleep 0.2
v4l2-ctl -d $camdev   -c zoom_absolute=0
sleep 0.2
v4l2-ctl -d $camdev   -c zoom_absolute=1
}


function resetcam
{
cat <<EOF
v4l2-ctl -d $camdev -c brightness=50
v4l2-ctl -d $camdev -c contrast=50
v4l2-ctl -d $camdev -c saturation=50
v4l2-ctl -d $camdev -c hue=50
v4l2-ctl -d $camdev -c white_balance_temperature_auto=1
v4l2-ctl -d $camdev -c white_balance_red_component=0
v4l2-ctl -d $camdev -c white_balance_blue_component=0
v4l2-ctl -d $camdev -c gain=4
v4l2-ctl -d $camdev -c power_line_frequency=1 
v4l2-ctl -d $camdev -c white_balance_temperature=5000
v4l2-ctl -d $camdev -c sharpness=58
v4l2-ctl -d $camdev -c backlight_compensation=9
v4l2-ctl -d $camdev -c exposure_auto=2
v4l2-ctl -d $camdev -c exposure_absolute=330
v4l2-ctl -d $camdev -c focus_auto=1
v4l2-ctl -d $camdev -c zoom_continuous=50
v4l2-ctl -d $camdev -c pan_speed=20
v4l2-ctl -d $camdev -c tilt_speed=20
EOF
}
set `echo $*`
export camdev=$1
export camfunc=$2
export parm=$3
echo camdev $camdev camfunc $camfunc parm $parm >> /tmp/camctl.sh.log
echo camdev : $camdev camfunc : $camfunc parm :  $parm
# v4l2-ctl -d $camdev -l

case $camfunc in 
resetcam)
$camfunc |while read cmd
do
# echo about to $cmd
$cmd
 sleep 0.1
done
pantilt

;;

exposure_absolute|gain|pan_absolute|tilt_absolute|zoom_absolute:sharpness)

echo v4l2-ctl -d $camdev -c $camfunc=$parm
v4l2-ctl -d $camdev -c $camfunc=$parm
# $camfunc $parm
;;


pantilt)
pantilt
;;

esac

